//draws rose diagram in PostScript

#include <u.h>
#include <libc.h>
#include <bio.h>
#include "plot.h"

#define HALFWIDTH 8192	/* output scaled to fit in -HALFWIDTH,HALFWIDTH */
#define MINVALUE  -1e10
#define MAXLENGTH 65536
#ifndef PI
#define PI	3.1415926535897932384626433832795028841971693993751
#endif

#define TWOPI (2*PI)

static int n;
static double f[360];
static double fmax;
static int left = -HALFWIDTH;
static int right = HALFWIDTH;
static int bottom = -HALFWIDTH;
static int top = HALFWIDTH;

double findmax(void);
void drw(void);
int readdata(void);

void
main()
{
	readdata();
	fmax=findmax();
	openpl();
	erase();
	drw();
	closepl();

}

double
findmax()
{
int i;
double max;
	max=MINVALUE;
	for(i=0; i<n; i++)
		if(f[i]>max) max=f[i];
	return max;
}


void
drw()
{
	int i, ax, ay, bx, by, cx, cy;
	double alpha, omega, scaling;
	cx=0; cy=0;

	alpha=TWOPI/n;
	omega=-alpha/2.0;
	scaling=HALFWIDTH/fmax;
	pen(SOLID);
	range(left,bottom,right,top);

	for(i=0; i<n+1; i++) //WHY the hell n+1?????
	{
		move(cx, cy);
		ax=(int)f[i]*sin(omega)*scaling;
		ay=(int)f[i]*cos(omega)*scaling;
		vec(ax, ay);
		omega+=alpha;
		bx=(int)f[i]*sin(omega)*scaling;
		by=(int)f[i]*cos(omega)*scaling;
		vec(bx, by);
		vec(cx, cy);
	}
	print("fill\n");
}

int 
readdata()
// read whitespace-delimited vector f[i] (external)
{
	Biobuf bin;
	char *buf, *av[MAXLENGTH];
	int  j;

	Binit(&bin, 0, OREAD);
	if((buf = Brdstr(&bin, '\n', 1)) != nil){
		n=tokenize(buf, av, MAXLENGTH);
		for(j=0; j<n; j++){
			f[j]=atof(av[j]);
		}
		free(buf);
	}
	return 1;
}
